| #!/bin/sh -eux |
| |
| # Licensed under the Apache License, Version 2.0 (the "License"); |
| # you may not use this file except in compliance with the License. |
| # You may obtain a copy of the License at |
| # |
| # http://www.apache.org/licenses/LICENSE-2.0 |
| # |
| # Unless required by applicable law or agreed to in writing, software |
| # distributed under the License is distributed on an "AS IS" BASIS, |
| # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| # See the License for the specific language governing permissions and |
| # limitations under the License. |
| |
| case "$PACKER_BUILDER_TYPE" in |
| qemu) exit 0 ;; |
| esac |
| |
| # Whiteout root |
| count=$(df --sync -kP / | tail -n1 | awk -F ' ' '{print $4}') |
| count=$(($count-1)) |
| dd if=/dev/zero of=/tmp/whitespace bs=1M count=$count || echo "dd exit code $? is suppressed"; |
| rm /tmp/whitespace |
| |
| # Whiteout /boot |
| count=$(df --sync -kP /boot | tail -n1 | awk -F ' ' '{print $4}') |
| count=$(($count-1)) |
| dd if=/dev/zero of=/boot/whitespace bs=1M count=$count || echo "dd exit code $? is suppressed"; |
| rm /boot/whitespace |
| |
| set +e |
| swapuuid="`/sbin/blkid -o value -l -s UUID -t TYPE=swap`"; |
| case "$?" in |
| 2|0) ;; |
| *) exit 1 ;; |
| esac |
| set -e |
| |
| if [ "x${swapuuid}" != "x" ]; then |
| # Whiteout the swap partition to reduce box size |
| # Swap is disabled till reboot |
| swappart="`readlink -f /dev/disk/by-uuid/$swapuuid`"; |
| /sbin/swapoff "$swappart"; |
| dd if=/dev/zero of="$swappart" bs=1M || echo "dd exit code $? is suppressed"; |
| /sbin/mkswap -U "$swapuuid" "$swappart"; |
| fi |
| |
| sync; |